<?php

namespace Ulmus\Api\Gitea;

class ApiResponseHandler
{
    public static function handle(\Psr\Http\Message\ResponseInterface $response, \Ulmus\Api\Attribute\Obj\Api\ApiAction $attribute) : mixed
    {
        $json = $response->render();

        if ($json['message'] ?? false) {
            if ( array_key_exists('errors', $json) && null === $json['errors'] ?? null) {
                if ($attribute instanceof \Ulmus\Api\Attribute\Obj\Api\Collection) {
                    return [];
                }
                elseif ($attribute instanceof \Ulmus\Api\Attribute\Obj\Api\Read) {
                    return null;
                }
                elseif ($attribute instanceof \Ulmus\Api\Attribute\Obj\Api\Create) {
                    return false;
                }
            }

            throw new \Exception($json['message']);
        }

        return $json;
    }
}